Summary: The most commonly-used entries in the /dev directory.
Name: dev
Version: 2.7.12
Release: 14mdk
Source0: dev-%{PACKAGE_VERSION}.tar.bz2
Source1: snddevices
Copyright: public domain
Group: System/Kernel and hardware
Buildroot: %{_tmppath}/dev-root
Autoreqprov: no
Prefix: /dev
Requires: shadow-utils >= 970616-7
Prereq: mktemp grep sed fileutils textutils /usr/bin/perl
Prereq: shadow-utils

%description
The Linux Mandrake operating system uses file system entries to represent
devices (CD-ROMs, floppy drives, etc.) attached to the machine. All of
these entries are in the /dev tree (although they don't have to be). 
This package contains the most commonly used /dev entries.  

The dev package is a basic part of your Linux Mandrake system and it needs
to be installed.

%prep
%setup -c -T

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
BUILD_DIR=`pwd`

# Make sure that the floppy group exists on the build machine
/usr/sbin/groupadd -g 19 -r -f floppy > /dev/null
/usr/sbin/groupadd -g 20 -r -f console > /dev/null
/usr/sbin/groupadd -g 65 -r -f audio > /dev/null
/usr/sbin/groupadd -g 66 -r -f x10 >/dev/null
/usr/sbin/groupadd -g 67 -r -f radio >/dev/null

# unpack in build root
( cd $RPM_BUILD_ROOT
  bzcat $RPM_SOURCE_DIR/dev-%{PACKAGE_VERSION}.tar.bz2 |tar xpS
)


# tar doesn't save some permissions unless the p option is used
# this code protects against dev package updaters forgetting to
# use the p option when unpacking the souce tarball.
for dev in zero null tty ttyp0 ; do
  if [ ! $(ls -l $dev | awk '{print $1}') = crw-rw-rw- ] ; then
    echo bad permissions on device $dev 1>&2
    exit 1
  fi
done

# do some cleanup in build root
cd $RPM_BUILD_ROOT/dev

# SPARC specific devices
%ifarch sparc
ln -s sunmouse mouse
mknod kbd c 11 0
chmod 0600 kbd
mknod openprom c 10 139
%endif

mkdir -p usb/
mknod usb/usblp0 c 180 0
mknod usb/usbmouse0 c 13 32
ln -s usb/usbmouse0 usbmouse 
mknod usb/usbscanner0 c 180 48
for i in 0 1 2 3;do
		mknod usb/usbjs$i c 13 0
done
for i in 0 1 2 3;do
		mknod usb/ttyACM$i c 166 0
done
for i in 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15;do
mknod usb/ttyUSB$i c 188 0
done

# more recent fd0 Floppy devices
mknod fd0u1440 b 2 28
mknod fd0u2880 b 2 32
mknod fd0u3200 b 2 104
mknod fd0u3520 b 2 108
mknod fd0u3840 b 2 112

# more recent fd1 Floppy devices
mknod fd1u1440 b 2 29
mknod fd1u2880 b 2 33
mknod fd1u3200 b 2 105
mknod fd1u3520 b 2 109
mknod fd1u3840 b 2 113

rm isdn*

# Agp
mknod agpgart c 10 175

#
mknod sg8 c 21 8 -m 640 
mknod sgi c 21 8 -m 640 
mknod sg9 c 21 9 -m 640 
mknod sgj c 21 9 -m 640 
mknod sg10 c 21 10 -m 640 
mknod sgk c 21 10 -m 640 
mknod sg11 c 21 11 -m 640 
mknod sgl c 21 11 -m 640 
mknod sg12 c 21 12 -m 640 
mknod sgm c 21 12 -m 640 
mknod sg13 c 21 13 -m 640 
mknod sgn c 21 13 -m 640 
mknod sg14 c 21 14 -m 640 
mknod sgo c 21 14 -m 640 
mknod sg15 c 21 15 -m 640 
mknod sgp c 21 15 -m 640 
mknod sg16 c 21 16 -m 640 
mknod sgq c 21 16 -m 640 
mknod sr0 b 11 0 -m 664 
mknod sr1 b 11 1 -m 660 
mknod sr2 b 11 2 -m 660 
mknod sr3 b 11 3 -m 660 
mknod sr4 b 11 4 -m 660 
mknod sr5 b 11 5 -m 660 
mknod sr6 b 11 6 -m 660 
mknod sr7 b 11 7 -m 660 
mknod sr8 b 11 8 -m 660 
mknod sr9 b 11 9 -m 660 
mknod scd8 b 11 8 -m 660 
mknod scd9 b 11 9 -m 660 
chgrp cdwriter sg?
chgrp cdwriter scd?
chgrp cdwriter sr?

#Local usr audio stuff
chown root:audio audio* dsp* mixer* midi* sequencer
chmod 000 audio* dsp* mixer* midi* sequencer
chmod u+rw audio* dsp* mixer* midi* sequencer
chmod g+rw audio* dsp* mixer* midi* sequencer

#X10 support
mknod x10-0 c 4 64
mknod x10-1 c 4 65
mknod x10-2 c 4 66
mknod x10-3 c 4 67
chown root:x10 x10-?
chmod 000 x10-?
chmod u+rw x10-?
chmod g+rw x10-?

#	Add ALSA entries
	cp %{SOURCE1} .
	chmod +x snddevices
	perl -pi -e "s| /dev| $RPM_BUILD_ROOT/dev|g" snddevices
	perl -pi -e "s|ln -svf $RPM_BUILD_ROOT|ln -svf |g" snddevices
	perl -pi -e "s|ln -svf |ln -sf |g" snddevices
	./snddevices
	rm -f snddevices

cd $BUILD_DIR
(cd $RPM_BUILD_ROOT/dev; ls) | sed 's,^,/dev/,' | sed '{
  /\/dev\/log$/ s/^/%ghost /
  /\/dev\/fd..*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/fb.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/video.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/radio.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/winradio.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/vtx.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/vbi.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/kbd.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/audio.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/js.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/cua.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/dsp*.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/midi.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/mixer.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/sequencer/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/sndstat.*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/tty[SCDEIMR].*/ s/^/%verify(not group,mode,mtime) /
  /\/dev\/tty[a-z].$/ s/^/%verify(size) /
  /\/dev\/pty.*/ s/^/%verify(size) /
  /\/dev\/raw\/.*/ s/^/%verify(not user,group,mode,mtime) /
}' > filelist

# that "size" should really be "maj,min" but rpm doesn't
# follow Maximum RPM's documentation of %verify...

%clean 
rm -rf $RPM_BUILD_ROOT

%pre
# Make sure that the needed groups exist on the install machine
/usr/sbin/groupadd -g 19 -r -f floppy > /dev/null
/usr/sbin/groupadd -g 20 -r -f console > /dev/null
/usr/sbin/groupadd -g 65 -r -f audio > /dev/null
/usr/sbin/groupadd -g 66 -r -f x10 >/dev/null
/usr/sbin/groupadd -g 67 -r -f radio >/dev/null

%post
if [ -f /etc/fstab ] ; then
  # add /dev/pts to fstab if fstab exists (install2 does it during install)
  if grep 'devpts' /etc/fstab >/dev/null 2>&1 ; then 
      # correct permissions from broken dev packages
     LC_ALL=C \
      perl -pi -e 's/devpts.*mode=0622/devpts  gid=5,mode=620/' /etc/fstab
  else
    # note that we do not disallow comments; we wish to allow people
    # to comment it out if they so desire.
    if [ $(grep '/proc' /dev/fstab 2>/dev/null | wc -l) -gt 1 ] ; then
      # ugly but robust
      echo '
none                    /dev/pts                devpts  gid=5,mode=620        0 0' \
        >> /etc/fstab || { echo "failed to add devpts filesystem to /etc/fstab" 1>&2 ; exit 1 ; }
    else
      # beautiful in the common case
      TMP=$(mktemp /tmp/fstab.XXXXXX)
      sed '/\/proc/a\
none                    /dev/pts                devpts  gid=5,mode=620        0 0
          ' < /etc/fstab > $TMP && cat $TMP > /etc/fstab || { echo "failed to add devpts filesystem to /etc/fstab" 1>&2 ; exit 1 ; }
      rm -f $TMP
    fi
  fi
fi

%files -f filelist

%changelog
* Thu May  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.7.12-14mdk
- Add the new node for usb mouse and a lot of new devices for usb
  (also move them to /dev/usb/).

* Thu Mar 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.7.12-13mdk
- Add agppart entry.

* Thu Mar  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.7.12-12mdk
- Move /dev/ entry of cdrecord package here (#78).

* Wed Jan 12 2000 Philippe Libat <philippe@mandrakesoft.com>
- Sun entries
- add audio x10 radio group on the build machine

* Thu Dec 02 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- Add ALSA entries (chmou sucks...)

* Thu Dec 02 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- unset locales before using perl.

* Wed Dec  1 1999 Pixel <pixel@linux-mandrake.com>
- fixed buggy %post leaving fstab.XXXX in /tmp

* Wed Oct 20 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Merge with redhat packages.


* Sat Aug 21 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- add /dev/radio, with read write access for group radio
- add /dev/x10*, with read write access for group x10 

* Tue Jul 20 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- add french description from Gregus <gregus@etudiant.net>

* Wed Jul  7 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- add group audio 

* Wed Jun 23 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Merging with RedHat:
	- changed %post script to mount /dev/pts with the proper permissions
	- added a great many devices, mostly from the 2.2 kernel,
	  regularized some permissions
	- now have all the sd* devices that are mentioned in Devices.txt
	- joystick entries
	- changed a requires line to a prereq line for the %post
	- deal properly with fstab files with multiple proc entries
	- /dev/kbd files will be managed by pam_console like /dev/fb
	- /dev/fb devices are not sparc-specific and permissions will
	  change as they are managed by pam_console by default.
	- make sure permissions on /etc/fstab do not change while adding
	  devpts filesystem
	- added m68k devices from puffin
	- fixed permissions on audio devices
	- added devices for Multitech IntelligentSerialInternal (isicom)
	- added permission check so that careless tar use will not mangle permissions
	- /dev/tty set to 666
	- nb devices
	- made /dev/zero world-writable again
	- added entries for DAC960 and Compaq Smart/2 RAID array controllers


* Mon May 24 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.com>
- add /dev/fd0u* devices for ED (2880k)-Floppies
- add /dev/fd0u1440, which shall replace the deprecated /dev/fd0H1440

* Tue May 18 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- add USB devices
- remove ISDN devices (we get them from isdn4k-utils - without isdn4k-utils
  we can't use them anyways.)

* Mon Apr 12 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Update to 2.7.3 with the RedHat version.

* Fri Apr  9 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Mandrake adaptions
- add de locale

* Tue Mar 09 1999 Michael Johnson <johnsonm@redhat.com>
- fixed logic for case when /etc/fstab does not exist

* Tue Feb 23 1999 Michael Johnson <johnsonm@redhat.com>
- added ptmx and pts, moved console to 5,1
  NB: we add devpts to /etc/fstab if it is not there; folks who
  for any reason don't want to use devpts should COMMENT OUT (not
  remove) the line and we will try not to add it again in the
  future.
- opened permissions back up on old-style ptys

* Tue Feb 23 1999 Matt Wilson <msw@redhat.com>
- yes, sparcs have IDE devices now, you *need* those devices.

* Mon Dec 14 1998 Michael K. Johnson <johnsonm@redhat.com>
- console-config is dead
- permission check limiting is still the right thing to do, though,
  for whatever replaces console-config

* Wed Dec 09 1998 Michael K. Johnson <johnsonm@redhat.com>
- moved dynamically configured to archive (changed to tar)
- added console-config.d file
- limited permission checking for files console-config manages
- permissions changed to console-config defaults

* Fri May 08 1998 Michael K. Johnson <johnsonm@redhat.com>
- added paride devices

* Tue May 05 1998 Erik Troan <ewt@redhat.com>
- uses a filelist
- ghosts /dev/log

* Fri May 01 1998 Cristian Gafton <gafton@redhat.com>
- fixed groupadd call in the %install

* Fri Apr 24 1998 Prospector System <bugs@redhat.com>
- translations modified for de

* Thu Apr 23 1998 Prospector System <bugs@redhat.com>
- translations modified for fr, tr

* Thu Apr 23 1998 Erik Troan <ewt@redhat.com>
- fixed preinstall script

* Tue Apr 21 1998 Erik Troan <ewt@redhat.com>
- updated groupadd to work with upgrades where the floppy group already exists

* Mon Nov 10 1997 Michael K. Johnson <johnsonm@redhat.com>
- Added more ramdisk entries

* Wed Oct 29 1997 Michael K. Johnson <johnsonm@redhat.com>
- Added fd and ramdisk symlinks

* Fri Oct 24 1997 Michael K. Johnson <johnsonm@redhat.com>
- Added floppy group for floppies; made them group-writable.

* Tue Jul 08 1997 Erik Troan <ewt@redhat.com>
- added bpcd device

* Thu Apr 10 1997 Erik Troan <ewt@redhat.com>
- Added ftape devices

* Tue Mar 25 1997 Erik Troan <ewt@redhat.com>
- Fixed stdin, stdout devices.
- Moved rtc to cpio archive
- Added ISDN devices
